#ifndef DEFINES_H_
#define DEFINES_H_

//Definicje portw sterujcych
#define MODE_PULL_UP_REG PUEB
#define MODE_PIN_REG PINB
#define MODE_NR PB2
#define MODE_IS_NIKON (!(MODE_PIN_REG & (1<<MODE_NR)))
#define MODE_PULL_UP_ON MODE_PULL_UP_REG |= (1<<MODE_NR)
#define MODE_PULL_UP_OFF MODE_PULL_UP_REG &= ~(1<<MODE_NR)

#define SHOT_PULL_UP_REG PUEB
#define SHOT_PIN_REG PINB
#define SHOT_NR PB1
#define SHOT_IS_PRESSED (!(SHOT_PIN_REG & (1<<SHOT_NR)))
#define SHOT_PULL_UP_ON SHOT_PULL_UP_REG |= (1<<SHOT_NR)

#define IR_PORT_REG PORTB
#define IR_DDR_REG DDRB
#define IR_NR PB0
#define IR_AS_OUTPUT IR_DDR_REG |= (1<<IR_NR)
#define IR_ON IR_PORT_REG |= (1<<IR_NR)
#define IR_OFF IR_PORT_REG &= ~(1<<IR_NR)

//Definicje dla Timera0
#define BURST_FUNCT_ON TCCR0A = (1<<COM0A0)  //Toggle OC0A on Compare Match
#define BURST_FUNCT_OFF TCCR0A = 0x00
#define BURST_START TCCR0B = (1<<WGM02)|(1<<CS00)  //Tryb CTC, Preskaler = 1
#define BURST_STOP TCCR0B = (1<<WGM02)

//Definicje dla ramki standardu Nikona (ms)
#define START_PULSE 2
#define START_PAUSE 27.83
#define DATA_PULSE 0.4
#define FIRST_PAUSE 1.58
#define SECOND_PAUSE 3.58
#define NIKON_FRAME_PAUSE 63.2

//Definicje dla ramki standardu Canona (us)
#define PULSE_LENGTH 12  //12 zamiast 14 z uwagi na overhead
#define PULSE_NR 20
#define CANON_FRAME_PAUSE 7.33  //(ms)

#endif /* DEFINES_H_ */
